-- author: DD ModPassion
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
BaleWrapperAddon = {} function BaleWrapperAddon.initSpecialization() local schema = Vehicle.xmlSchema schema:setXMLSpecializationType("BaleWrapperAddon") schema:register(XMLValueType.STRING, "vehicle.baleWrapper.foilWrapAddon#storage", "storage configuration") schema:register(XMLValueType.INT, "vehicle.baleWrapper.foilWrapAddon#configuration", "configuration index") schema:register(XMLValueType.NODE_INDEX, "vehicle.baleWrapper.foilWrapAddon.baseNode(?)#node", "node to hide") schema:register(XMLValueType.STRING, "vehicle.baleWrapper.foilWrapAddon.baseNode(?)#texture", "texture file") schema:register(XMLValueType.NODE_INDEX, "vehicle.baleWrapper.foilWrapAddon.roll(?)#node", "roll node") schema:register(XMLValueType.VECTOR_TRANS, "vehicle.baleWrapper.foilWrapAddon.roll(?)#translation", "translation roll") schema:register(XMLValueType.VECTOR_ROT, "vehicle.baleWrapper.foilWrapAddon.roll(?)#rotation", "rotation roll") schema:register(XMLValueType.VECTOR_SCALE, "vehicle.baleWrapper.foilWrapAddon.roll(?)#scale", "scale roll") schema:register(XMLValueType.NODE_INDEX, "vehicle.baleWrapper.foilWrapAddon.storage(?)#node", "storage node") schema:register(XMLValueType.VECTOR_TRANS, "vehicle.baleWrapper.foilWrapAddon.storage(?)#translation", "translation storage") schema:register(XMLValueType.VECTOR_ROT, "vehicle.baleWrapper.foilWrapAddon.storage(?)#rotation", "rotation storage") schema:register(XMLValueType.VECTOR_SCALE, "vehicle.baleWrapper.foilWrapAddon.storage(?)#scale", "scale storage") schema:register(XMLValueType.NODE_INDEX, "vehicle.baleWrapper.foilWrapAddon.material(?)#node", "material node") schema:register(XMLValueType.BOOL, "vehicle.baleWrapper.foilWrapAddon.material(?)#editVisibility", "edit visibility", true) schema:setXMLSpecializationType() end function BaleWrapperAddon.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(BaleWrapper, specializations) and SpecializationUtil.hasSpecialization(FillUnit, specializations) and SpecializationUtil.hasSpecialization(FoilWrapAddon, specializations) end function BaleWrapperAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", BaleWrapperAddon) end function BaleWrapperAddon.registerOverwrittenFunctions(vehicleType) SpecializationUtil.registerOverwrittenFunction(vehicleType, "allowsGrabbingBale", BaleWrapperAddon.allowsGrabbingBale) end function BaleWrapperAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) if self:getIsActive() or self:getIsAIActive() or self:getIsPowered() then local spec = self.spec_foilWrapAddon if self:getFillUnitFillLevel(spec.foilWrapFillUnit) > 0 then if self.spec_baleWrapper.baleWrapperState == BaleWrapper.STATE_WRAPPER_WRAPPING_BALE and NetworkUtil.getObject(self.spec_baleWrapper.currentWrapper.currentBale) ~= nil then for i = 1, #spec.foilWrapRoll.volume do local _, y, _ = getRotation(spec.foilWrapRoll.volume[i].node) setRotation(spec.foilWrapRoll.volume[i].node, 0, y - 0.01, 0) end local fillDelta = 100 local diameter = NetworkUtil.getObject(self.spec_baleWrapper.currentWrapper.currentBale).diameter local length = NetworkUtil.getObject(self.spec_baleWrapper.currentWrapper.currentBale).length if diameter > 0 then if diameter > 1.50 then fillDelta = 122.11 elseif diameter > 1.25 then fillDelta = 92.12 elseif diameter > 0 then fillDelta = 70.15 end else if length > 180 then fillDelta = 105.63 elseif length > 220 then fillDelta = 99.76 elseif length > 0 then fillDelta = 88.02 end end spec.baleFoilWrapUsed = fillDelta fillDelta = dt * (fillDelta / self:getAnimationDuration(self.spec_baleWrapper.currentWrapper.animations.wrapBale.animName)) local stats = g_currentMission:farmStats(self:getOwnerFarmId()) stats:updateStats("foilWrapUsage", fillDelta) if g_currentMission.missionInfo.helperBuyFoilWrap and self:getIsAIActive() then local price = fillDelta * g_currentMission.economyManager:getCostPerLiter(FillType.FOILWRAP, false) * 1.5 stats:updateStats("expenses", price) g_currentMission:addMoney(-price, farmId, MoneyType.PURCHASE_FOILWRAP, true, true) else self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.foilWrapFillUnit, -fillDelta, self:getFillUnitFillType(spec.foilWrapFillUnit), ToolType.UNDEFINED, nil) end end if self:getFillUnitFillLevel(spec.foilWrapFillUnit) < spec.baleFoilWrapUsed and self.spec_baleWrapper.baleWrapperState ~= BaleWrapper.STATE_WRAPPER_WRAPPING_BALE then self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.foilWrapFillUnit, -self:getFillUnitFillLevel(spec.foilWrapFillUnit), self:getFillUnitFillType(spec.foilWrapFillUnit), ToolType.UNDEFINED, nil) end else _, spec.nearestBale, _ = BaleWrapper.getBaleInRange(self, self.spec_baleWrapper.baleGrabber.grabNode, self.spec_baleWrapper.baleGrabber.nearestDistance) end end end function BaleWrapperAddon:updateDebugValues(values) local spec = self.spec_foilWrapAddon if self.configurations.foilWrapAddon < 3 and spec.foilWrapFillUnit > 0 then if NetworkUtil.getObject(self.spec_baleWrapper.currentWrapper.currentBale) ~= nil then table.insert(values, {name = "Bale", value = string.format("diameter %.2f - lenght %.2f - height %.2f", NetworkUtil.getObject(self.spec_baleWrapper.currentWrapper.currentBale).diameter, NetworkUtil.getObject(self.spec_baleWrapper.currentWrapper.currentBale).length, NetworkUtil.getObject(self.spec_baleWrapper.currentWrapper.currentBale).height)}) else table.insert(values, {name = "Bale", value = string.format("none")}) end end end function BaleWrapperAddon:allowsGrabbingBale(superFunc) local spec = self.spec_baleWrapper if self.configurations.foilWrapAddon < 3 and self.spec_foilWrapAddon.foilWrapFillUnit > 0 then if self:getFillUnitFillLevel(self.spec_foilWrapAddon.foilWrapFillUnit) <= 0 then return false end end local specFoldable = self.spec_foldable if specFoldable ~= nil and specFoldable.foldAnimTime ~= nil and (spec.currentWrapperFoldMaxLimit < specFoldable.foldAnimTime or specFoldable.foldAnimTime < spec.currentWrapperFoldMinLimit) then return false end if spec.baleToLoad ~= nil then return false end return spec.baleWrapperState == BaleWrapper.STATE_NONE end