-- author: DD ModPassion
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
InlineWrapperAddon = {} function InlineWrapperAddon.initSpecialization() local schema = Vehicle.xmlSchema schema:setXMLSpecializationType("InlineWrapperAddon") schema:register(XMLValueType.STRING, "vehicle.inlineWrapper.foilWrapAddon#storage", "storage configuration") schema:register(XMLValueType.INT, "vehicle.inlineWrapper.foilWrapAddon#configuration", "configuration index") schema:register(XMLValueType.NODE_INDEX, "vehicle.inlineWrapper.foilWrapAddon.baseNode(?)#node", "node to hide") schema:register(XMLValueType.STRING, "vehicle.inlineWrapper.foilWrapAddon.baseNode(?)#texture", "texture file") schema:register(XMLValueType.NODE_INDEX, "vehicle.inlineWrapper.foilWrapAddon.roll(?)#node", "roll node") schema:register(XMLValueType.VECTOR_TRANS, "vehicle.inlineWrapper.foilWrapAddon.roll(?)#translation", "translation roll") schema:register(XMLValueType.VECTOR_ROT, "vehicle.inlineWrapper.foilWrapAddon.roll(?)#rotation", "rotation roll") schema:register(XMLValueType.VECTOR_SCALE, "vehicle.inlineWrapper.foilWrapAddon.roll(?)#scale", "scale roll") schema:register(XMLValueType.NODE_INDEX, "vehicle.inlineWrapper.foilWrapAddon.storage(?)#node", "storage node") schema:register(XMLValueType.VECTOR_TRANS, "vehicle.inlineWrapper.foilWrapAddon.storage(?)#translation", "translation storage") schema:register(XMLValueType.VECTOR_ROT, "vehicle.inlineWrapper.foilWrapAddon.storage(?)#rotation", "rotation storage") schema:register(XMLValueType.VECTOR_SCALE, "vehicle.inlineWrapper.foilWrapAddon.storage(?)#scale", "scale storage") schema:register(XMLValueType.NODE_INDEX, "vehicle.inlineWrapper.foilWrapAddon.material(?)#node", "node") schema:register(XMLValueType.BOOL, "vehicle.inlineWrapper.foilWrapAddon.material(?)#editVisibility", "edit visibility", true) schema:setXMLSpecializationType() end function InlineWrapperAddon.prerequisitesPresent(specializations) return SpecializationUtil.hasSpecialization(InlineWrapper, specializations) and SpecializationUtil.hasSpecialization(FillUnit, specializations) and SpecializationUtil.hasSpecialization(FoilWrapAddon, specializations) end function InlineWrapperAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", InlineWrapperAddon) end function InlineWrapperAddon.registerOverwrittenFunctions(vehicleType) SpecializationUtil.registerOverwrittenFunction(vehicleType, "getIsInlineBalingAllowed", InlineWrapperAddon.getIsInlineBalingAllowed) end function InlineWrapperAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) if self:getIsActive() or self:getIsAIActive() or self:getIsPowered() then local spec = self.spec_foilWrapAddon if self:getFillUnitFillLevel(spec.foilWrapFillUnit) > 0 then if self:getIsAnimationPlaying(self.spec_inlineWrapper.animations.wrapping) and self:getCurrentInlineBale() ~= nil then for i = 1, #spec.foilWrapRoll.volume do local _, y, _ = getRotation(spec.foilWrapRoll.volume[i].node) setRotation(spec.foilWrapRoll.volume[i].node, 0, y - 0.01, 0) end local fillDelta = 0 local diameter =  self:getCurrentInlineBale().bales[#self:getCurrentInlineBale().bales].diameter local height =  self:getCurrentInlineBale().bales[#self:getCurrentInlineBale().bales].height local length =  self:getCurrentInlineBale().bales[#self:getCurrentInlineBale().bales].length if diameter > 0 then fillDelta = diameter * math.pi * #spec.foilWrapRoll.volume else fillDelta = (height + length) * #spec.foilWrapRoll.volume end spec.baleFoilWrapUsed = fillDelta fillDelta = fillDelta / dt local stats = g_currentMission:farmStats(self:getOwnerFarmId()) stats:updateStats("foilWrapUsage", fillDelta) if g_currentMission.missionInfo.helperBuyFoilWrap and self:getIsAIActive() then local price = fillDelta * g_currentMission.economyManager:getCostPerLiter(FillType.FOILWRAP, false) * 1.5 stats:updateStats("expenses", price) g_currentMission:addMoney(-price, farmId, MoneyType.PURCHASE_FOILWRAP, true, true) else self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.foilWrapFillUnit, -fillDelta, self:getFillUnitFillType(spec.foilWrapFillUnit), ToolType.UNDEFINED, nil) end end end end end function InlineWrapperAddon:updateDebugValues(values) local spec = self.spec_foilWrapAddon if self.configurations.foilWrapAddon < 3 and spec.foilWrapFillUnit > 0 then if self:getCurrentInlineBale() ~= nil then table.insert(values, {name = "Bale", value = string.format("diameter %.2f - lenght %.2f - height %.2f", self:getCurrentInlineBale().bales[#self:getCurrentInlineBale().bales].diameter, self:getCurrentInlineBale().bales[#self:getCurrentInlineBale().bales].length, self:getCurrentInlineBale().bales[#self:getCurrentInlineBale().bales].height)}) else table.insert(values, {name = "Bale", value = string.format("none")}) end end end function InlineWrapperAddon:getIsInlineBalingAllowed(superFunc) local spec = self.spec_inlineWrapper if self.configurations.foilWrapAddon < 3 and self.spec_foilWrapAddon.foilWrapFillUnit > 0 then if self:getFillUnitFillLevel(self.spec_foilWrapAddon.foilWrapFillUnit) == 0 then return false end end if self.getFoldAnimTime ~= nil then local foldTime = self:getFoldAnimTime() if foldTime < spec.minFoldTime or spec.maxFoldTime < foldTime then return false end end if self:getIsAnimationPlaying(spec.animations.pusher) then return false end if self:getIsAnimationPlaying(spec.animations.pushOff) or self:getAnimationTime(spec.animations.pushOff) > 0 then return false end return true end